#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include "UnrealPropertyBase.h"

struct MapProperty : public UnrealPropertyBase {
    using ptr = Containers::Pointer<MapProperty>;

    MapProperty() {
        propertyType = "MapProperty";
    }

    std::string keyType;
    std::string valueType;

    struct KeyValuePair {
        UnrealPropertyBase::ptr key;
        Containers::Array<UnrealPropertyBase::ptr> values;
    };

    Containers::Array<KeyValuePair> map;
};
